###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2011 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################

# keep around ready for later user
## global alphatag rc4

Name: rgmanager
Summary: Open Source HA Resource Group Failover for Red Hat Cluster
Version: 3.0.12.1
Release: 5%{?alphatag:.%{alphatag}}%{?dist}
License: GPLv2+ and LGPLv2+
Group: System Environment/Base
URL: http://sources.redhat.com/cluster/wiki/
Source0: https://fedorahosted.org/releases/c/l/cluster/%{name}-%{version}.tar.bz2
Patch0: bz690191_rgmanager_improve_exclusive_prioritization_handling.patch
Patch1: bz716231_fix_bad_passing_of_sfl_failure_up.patch
Patch2: bz692895_fix_segfault_on_config_reload.patch
Patch3: bz673167_make_handling_of_failed_services_consistent.patch
Patch4: bz697446-fix_race_in_shutdown_vs_notification.patch
Patch5: bz697446-2-fix_segfault_caused_by_unref_race.patch
Patch6: bz723925-add_disabled_configuration_option.patch
Patch7: bz734730-fix_uninitialized_variable.patch
Patch8: bz741607-clean_up_dbus_concurrency.patch
Patch9: bz741607-2-block_signals_when_dealing_with_dbus.patch

## runtime

Requires(post): chkconfig
Requires(preun): initscripts
Requires(preun): chkconfig
Requires: chkconfig initscripts 
Requires: cman dbus
Requires: resource-agents >= 3.9.1-1
Obsoletes: resource-agents < 3.9.1

## Setup/build bits

BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

# Build dependencies
BuildRequires: clusterlib-devel >= 3.0.0-1
BuildRequires: libxml2-devel ncurses-devel slang-devel
BuildRequires: dbus-devel

ExclusiveArch: i686 x86_64

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1 -b .bz690191_rgmanager_improve_exclusive_prioritization_handling
%patch1 -p1 -b .bz716231_fix_bad_passing_of_sfl_failure_up
%patch2 -p1 -b .bz692895_fix_segfault_on_config_reload
%patch3 -p1 -b .bz673167_make_handling_of_failed_services_consistent
%patch4 -p1 -b .bz697446.1
%patch5 -p1 -b .bz697446.2
%patch6 -p1 -b .bz723925.1
%patch7 -p1 -b .bz734730.1
%patch8 -p1 -b .bz741607.1
%patch9 -p1 -b .bz741607.2

%build
./configure \
  --sbindir=%{_sbindir} \
  --initddir=%{_sysconfdir}/rc.d/init.d \
  --libdir=%{_libdir} \
  --disable_kernel_check

##CFLAGS="$(echo '%{optflags}')" make %{_smp_mflags}
CFLAGS="$(echo '%{optflags}')" make -C rgmanager all

%install
rm -rf %{buildroot}
make -C rgmanager install DESTDIR=%{buildroot}

%clean
rm -rf %{buildroot}

%description
Red Hat Resource Group Manager provides high availability of critical server
applications in the event of planned or unplanned system downtime.

%post
/sbin/chkconfig --add rgmanager

%preun
if [ "$1" = 0 ]; then
	/sbin/service rgmanager stop >/dev/null 2>&1
	/sbin/chkconfig --del rgmanager
fi

%files
%defattr(-,root,root,-)
%doc doc/COPYING.* doc/COPYRIGHT doc/README.licence rgmanager/README rgmanager/errors.txt
%{_sysconfdir}/rc.d/init.d/rgmanager
%{_sbindir}/clu*
%{_sbindir}/rgmanager
%{_sbindir}/rg_test
%{_datadir}/cluster
%{_mandir}/man8/clu*
%{_mandir}/man8/rgmanager*

%changelog
* Wed Oct 19 2011 Lon Hohberger <lhh@redhat.com> - 3.0.12.1-5
- rgmanager: Clean up DBus concurrency
  rgmanager: Block signals when dealing with dbus
  Resolves: rhbz#741607

* Thu Sep 08 2011 Lon Hohberger <lhh@redhat.com> - 3.0.12.1-4
- rgmanager: Fix segfault caused by unref race
  Resolves: rhbz#697446
- rgmanager: Fix uninitialized variable
  Resolves: rhbz#734730

* Tue Aug 02 2011 Lon Hohberger <lhh@redhat.com> - 3.0.12.1-3
- rgmanager: Fix race in shutdown vs. notification
  Resolves: rhbz#697446
- rgmanager: Add 'disabled' configuration option
  Resolves: rhbz#723925

* Wed Jul 13 2011 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.12.1-2
- Improve rgmanager's exclusive prioritization handling
  Resolves: rhbz#690191
- Fix bad passing of SFL_FAILURE up
  Resolves: rhbz#716231
- Fix segfault on config reload
  Resolves: rhbz#692895
- Make handling of failed services consistent
  Resolves: rhbz#673167

* Tue Jun 21 2011 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.12.1-1
- Rebase package on top of new upstream:
  * rgmanager: fix compiler warning in clulog.c
  * rgmanager: Add resource-defaults section
  * rgmanager: Fix clustat help & version operations
  * rgmanager: Make clustat -f not query CCS/objdb
  * rgmanager: Pause during exit if we stopped services
  * rgmanager: Fix reference count handling
- spec file update:
  * update spec file copyright date
  * drop all patches
  * update and clean configure and build section.
  * resync with fedora spec file
  Resolves: rhbz#707118
- Move rgmanager S/Lang from resource-agents to rgmanager:
  * Add versioned Requires/Obsoletes on resource-agents to avoid file conflicts
  Resolves: rhbz#693517

* Thu Feb 03 2011 Lon Hohberger <lhh@redhat.com> - 3.0.12-11
- rgmanager: Present flags in clustat output
  (present_flags_in_clustat_output.patch)
  Resolves: rhbz#634298
- rgmanager: Fix clustat return code
  (fix_clustat_return_code.patch)
  Resolves: rhbz#621562
- rgmanager: Honor restricted FDs during migrations
  (honor_restricted_fds_during_migrations.patch)
  Resolves: rhbz#621694
- rgmanager: Add non-critical flag to resources
  (add_non_critical_flag_to_resources.patch)
  rgmanager: Add non-critical base behavior
  (add_non_critical_base_behavior.patch)
  rgmanager: Header cleanup
  (header_cleanup.patch)
  rgmanager: Use rg_strings.c for flags
  (use_rg_strings_c_for_flags.patch)
  rgmanager: Present all flags in clustat output
  (present_all_flags_in_clustat_output.patch)
  rgmanager: Mark non-critical resources disabled
  (mark_non_critical_resources_disabled.patch)
  rgmanager: Add convalesce operation
  (add_convalesce_operation.patch)
  rgmanager: Allow restart,disable recovery policy
  (allow_restart,disable_recovery_policy.patch)
  rgmanager: Ensure state is preserved across config changes
  (ensure_state_is_preserved_across_config_changes.patch)
  rgmanager: Fix handling of independent subtrees
  (fix_handling_of_independent_subtrees.patch)
  rgmanager: Do not fail service if non-critical resources fail to stop
  (do_not_fail_service_if_non_critical_resources_fail_to_stop.patch)
  rgmanager: Add -c option to man page & clusvcadm -h
  (add_c_option_to_man_page_clusvcadm_h.patch)
  rgmanager: Add independent subtree restart thresholds
  (add_independent_subtree_restart_thresholds.patch)
  rgmanager: clean up independent subtree restart handling
  (clean_up_independent_subtree_restart_handling.patch)
  rgmanager: Fix corner case in critical/non-critical handling
  (fix_corner_case_in_critical_non_critical_handling.patch)
  rgmanager: Support convalesce w/ central_processing
  (support_convalesce_w_central_processing.patch)
  Resolves: rhbz#634277
- rgmanager: Update last_owner on failover
  (update_last_owner_on_failover.patch)
  Resolves: rhbz#639103
- rgmanager: DBus notifications for service state changes
  (dbus_notifications_for_service_state_changes.patch)
  rgmanager: Clean up dbus notifications
  (clean_up_dbus_notifications.patch)
  rgmanager: Retry dbus if we get disconnected
  (retry_dbus_if_we_get_disconnected.patch)
  rgmanager: minor dbus cleanups
  (minor_dbus_cleanups.patch)
  rgmanager: Match fenced's option to disable DBus
  (match_fenced_s_option_to_disable_dbus.patch)
  rgmanager: allow dbus notification code to be disabled
  (allow_dbus_notification_code_to_be_disabled.patch)
  Resolves: rhbz#657756
- rgmanager: Make clufindhostname -i predictable
  (make_clufindhostname_i_predictable.patch)
  Resolves: rhbz#661881
- rgmanager: Fix nofailback when service is in 'starting' state
  (fix_nofailback_when_service_is_in_starting_state.patch)
  Resolves: rhbz#672841

* Mon Jul 12 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-10
- Add failover domain documentation and other improvements
  (man_page_improvements.patch)
  Resolves: rhbz#557563

* Mon Jul 12 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-9
- Make clulog filter correctly based on cluster.conf
  (make_clulog_filter_correctly.patch)
  Resolves: rhbz#609866

* Mon Jul 12 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.12-8
- Fix patch file naming
  Related: rhbz#612110

* Fri Jul  9 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.12-7
- Fix rgmanager init script to be more LSB compliant
  (rgmanager_init_lsb_compliant.patch)
  Resolves: rhbz#612110

* Wed Jun 30 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-6
- Fix staged upgrade
  (fix_staged_upgrade.patch)
  Resolves: rhbz#609550

* Wed Jun 30 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-5
- Fix 3.0.12-3 changelog

* Tue Jun 29 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-3
- Use sysrq-b to reboot
  (use_sysrq_b_to_reboot.patch)
  Resolves: rhbz#609181

* Fri Jun 25 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-2
- Pass timeouts to resource agents
  (pass_timeouts_to_resource_agents.patch)
  Resolves: rhbz#606480

* Wed May 12 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.12-1
- Rebase on top of new upstream bug fix only release:
  * drop all bug fix patches.
  * Addresses the follwing issues from 3.0.12 release:
  Resolves: rhbz#588890, rhbz#588925, rhbz#589131, rhbz#588010
  * Rebase:
  Resolves: rhbz#582350
- Stop build on ppc and ppc64.
  Resolves: rhbz#591000

* Wed Apr  7 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.9-2
- Fix 2+ simultaneous relocation crash
  (fix_2_or_more_simultaneous_relocation_crash.patch)
  Resolves: rhbz#577856
- Fix meory leaks during relocation
  (fix_memory_leaks_during_relocation.patch)
  (fix_memory_leak_during_reconfig.patch)
  Resolves: rhbz#578249

* Tue Mar  2 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.9-1
- New upstream release
  Resolves: rhbz#569956, rhbz#569953
- spec file update:
  * update spec file copyright date
  * use bz2 tarball

* Thu Feb 25 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.7-2
- Resolves: rhbz#568011
- Do not build rgmanager on s390 and s390x.

* Tue Jan 12 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.7-1
- New upstream release

* Mon Dec  7 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.6-1
- New upstream release
- spec file cleanup:
  * use global instead of define
  * use new Source0 url
  * use %name macro more aggressively

* Fri Nov 20 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.5-1
- New upstream release

* Wed Oct 21 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.4-1
- New upstream release

* Tue Sep  1 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.3-1
- Split from cluster srpm
